// execselect.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "ini.h"
#include "execute.h"
#include <windows.h>
#include <fstream>

// j[ID̊l
#define BASE_MENU_ID 40000

/**
 * dÕ`FbNs
 */
#define MUTEX_GUID _T("{6286FEE8-242F-4db1-B21A-D8B004526EED}")
BOOL ExistInstance(HINSTANCE hInstance)
{
	CreateMutex(NULL, TRUE, MUTEX_GUID);
	return (GetLastError() == ERROR_ALREADY_EXISTS);
}

/**
 * ftHginit@C쐬
 */
void CreateDefaultIniFile(CIniFile &ini)
{
	std::wfstream stream(ini.GetIniFileName().c_str(), std::ios::out);
	if (stream.fail()) return;

	stream
		<< _T("# Internet Explorer") << std::endl
		<< _T("[1]") << std::endl
		<< _T("title=Internet Explorer") << std::endl
		<< _T("exec=iexplore.exe") << std::endl
		<< std::endl
		<< _T("# Opera") << std::endl
		<< _T("[2]") << std::endl
		<< _T("title=Opera") << std::endl
		<< _T("exec=\\Program Files\\Opera\\Opera.exe") << std::endl
		<< std::endl
		<< _T("# NetFront") << std::endl
		<< _T("[3]") << std::endl
		<< _T("title=NetFront") << std::endl
		<< _T("exec=\\Program Files\\netfront33\\netfront33.exe") << std::endl
		<< std::endl
		<< _T("[position]") << std::endl
		<< _T("# ") << std::endl
		<< _T("xAlign=0") << std::endl
		<< _T("yAlign=0") << std::endl
		<< std::endl
		<< _T("# ʒu") << std::endl
		<< _T("x=0") << std::endl
		<< _T("y=0") << std::endl
	;
	stream.close();

	ini.Load();
}

/**
 * j[̕\s
 */
BOOL ShowPopupMenu(CIniFile &ini, LPTSTR lpCmdLine)
{
	// j[쐬
	HMENU hMenu = CreatePopupMenu();
	if (!hMenu) return FALSE;

	// ini̓eTuj[
	int i = 1;
	while (true) {
		WCHAR buff[256];
		_itow_s(i, buff, 256, 10);
		try {
			std::wstring &title = ini.GetValue(buff, _T("title"));
			BOOL ret = AppendMenu(hMenu, 0, BASE_MENU_ID + i, title.c_str());
			if (!ret) return FALSE;
		} catch (wchar_t*) {
			break;
		}
		i++;
	}

	// ʒu̎擾
	int x = ini.GetIntValue(_T("position"), _T("x"), 0);
	int y = ini.GetIntValue(_T("position"), _T("y"), 0);
	UINT uFlag = TPM_RETURNCMD;
	switch (ini.GetIntValue(_T("position"), _T("xAlign"), 0)) {
		case 0:
			uFlag |= TPM_LEFTALIGN;
			break;
		case 1:
			x += GetSystemMetrics(SM_CXSCREEN) / 2;
			uFlag |= TPM_CENTERALIGN;
			break;
		case 2:
			x += GetSystemMetrics(SM_CXSCREEN);
			uFlag |= TPM_RIGHTALIGN;
			break;
	}
	switch (ini.GetIntValue(_T("position"), _T("yAlign"), 0)) {
		case 0:
			uFlag |= TPM_TOPALIGN;
			break;
		case 1:
			y += GetSystemMetrics(SM_CYSCREEN) / 2;
			uFlag |= TPM_VCENTERALIGN;
			break;
		case 2:
			y += GetSystemMetrics(SM_CYSCREEN);
			uFlag |= TPM_BOTTOMALIGN;
			break;
	}

	// \
	UINT id = TrackPopupMenu(hMenu, uFlag, x, y, 0, GetDesktopWindow(), NULL);

	// s
	BOOL result = FALSE;
	id -= BASE_MENU_ID;
	if (id < 1) return FALSE;
	WCHAR buff[256];
	_itow_s(id, buff, 256, 10);
	try {
		std::wstring &exec = ini.GetValue(buff, _T("exec"));
		std::wstring args = lpCmdLine;
		result = MomoLabUtil::ShellExecute(exec, args);
	} catch (wchar_t*) {
	}

	return result;
}

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	//dN`FbN
	if (ExistInstance(hInstance)) {
		return 1;
	}

	//init@CNX𐶐
	CIniFile ini(hInstance);
	if (ini.Fail()) {
		CreateDefaultIniFile(ini);
	}

	//j[\
	ShowPopupMenu(ini, lpCmdLine);

	return 0;
}
